<?php

namespace app\admin\controller;

use app\admin\common\AdminController;
use app\common\model\TalentQuit as TqModel;
use app\common\api\DictApi;
use app\common\state\MainState;
use app\common\model\TalentLog;
use app\common\state\ProjectState;
use think\facade\Db;

/**
 * Description of TalentQuit
 *
 * @author sgq
 */
class TalentQuit extends AdminController {

    public function index() {
        return view("", ["type" => $this->user["type"]]);
    }

    public function list() {
        $params = $this->request->param();
        $offset = $params["offset"] ?: 0;
        $order = $params["order"] ?: "desc";
        $limit = $params["limit"] ?: 10;
        $where = $this->setTalentQuit($params);
        $where[] = ["type", "=", $this->user["type"]];
        $where[] = ["delete", "=", 0];
        //获取字典表人才层次
        $levelMap = DictApi::selectByParentCode("talent_arrange");
        $typeMap = DictApi::selectByParentCode("enterprise_tag");
        $count = TqModel::where($where)->count();
        $list = TqModel::where($where)->limit($offset, $limit)->order("createTime {$order}")->select()->toArray();
        foreach ($list as $key => $item) {
            $list[$key]["talentArrangeName"] = $levelMap[$item["talentArrange"]];
            $list[$key]["talentTypeName"] = $typeMap[$item["talentType"]];
        }

        return json(["rows" => $list, "total" => $count]);
    }

    public function check() {
        $id = $this->request["id"];
        $info = TqModel::where("id", $id)->find();
        $info["talentArrangeName"] = DictApi::selectByParentCode("talent_arrange")[$info["talentArrange"]];
        if (\StrUtil::isNotEmpAndNull($info["talentType"])) {
            $info["talentTypeName"] = DictApi::selectByParentCode("enterprise_tag")[$info["talentType"]];
        }
        return view("check", ["type" => $this->user["type"], "row" => $info]);
    }

    public function submitToCheck() {
        $responseObj = new \stdClass();
        $responseObj->code = 500;
        $id = $this->request["id"];
        $checkState = $this->request["checkState"];
        $checkMsg = $this->request["checkMsg"];
        $info = TqModel::where("id", $id)->find();
        if (!$info) {
            $responseObj->msg = "系统错误，请联系管理员";
            return $responseObj;
        }
        if (strlen($info["talentId"]) == 19) {
            //旧系统申请兼容处理
            unset($where);
            $where[] = ["enterprise_id", "=", $info["enterpriseId"]];
            $where[] = ["card_number", "=", $info["idCard"]];
            $where[] = ["checkState", "=", \app\common\api\TalentState::CERTIFICATED];
            $where[] = ["active", "=", 1];
            $where[] = ["delete", "=", 0];
            $ti = \app\enterprise\model\Talent::where($where)->order("createTime desc")->find();
            if (!$ti) {
                $responseObj->msg = "未匹配到人才数据";
                return $responseObj;
            }
            $info["talentId"] = $ti["id"];
        }
        if (!$checkState) {
            $responseObj->msg = "请选择审核状态";
            return $responseObj;
        }
        Db::startTrans();
        try {
            //添加日志
            $user = $this->user;
            $log["id"] = getStringId();
            $log["active"] = 1;
            $log["state"] = $checkState;
            $log["step"] = 11;
            $log["stateChange"] = MainState::getStateName($info["checkState"]) . "->" . MainState::getStateName($checkState);
            $log["type"] = ProjectState::QUIT;
            $log["mainId"] = $id;
            $log["description"] = $checkMsg;
            $log["createUser"] = $user ? sprintf("%s(%s)", $user["account"], $user["companyName"] ?: $user["rolename"]) : "系统";
            $log["createTime"] = date("Y-m-d H:i:s");
            $updTalentQuit["id"] = $id;
            $updTalentQuit["checkState"] = $checkState;
            $updTalentQuit["checkMsg"] = $checkMsg;
            if ($checkState == 3) {
                //修改人才库信息
                $upd["id"] = $info["talentId"];
                $upd["active"] = 2;
                $upd["cur_quit_time"] = $info["quitTime"];
                Db::table("new_talent_info")->save($upd);

                $talentLog["id"] = getStringId();
                $talentLog["active"] = 1;
                $talentLog["step"] = 22;
                $talentLog["type"] = ProjectState::TALENT;
                $talentLog["mainId"] = $info["talentId"];
                $talentLog["description"] = "离职变更通过，同步到人才库";
                $talentLog["createUser"] = $user ? sprintf("%s(%s)", $user["account"], $user["companyName"] ?: $user["rolename"]) : "系统";
                $talentLog["createTime"] = date("Y-m-d H:i:s");
                Db::table("new_talent_checklog")->insert($talentLog);
                $updTalentQuit["passTime"] = date("Y-m-d H:i:s");
            }
            Db::table("new_talent_checklog")->insert($log);
            Db::table("un_talent_quit")->save($updTalentQuit);
            $responseObj->code = 200;
            $responseObj->msg = "审核成功";

            Db::commit();
            return $responseObj;
        } catch (\think\db\exception\DbException $e) {
            $responseObj->msg = $e->getMessage();
            Db::rollback();
            return $responseObj;
        }
    }

    public function export() {
        $request = $this->request;
        $data["talentName"] = \StrUtil::getRequestDecodeParam($request, "talentName");
        $data["idCard"] = \StrUtil::getRequestDecodeParam($request, "idCard");
        $data["enterpriseName"] = \StrUtil::getRequestDecodeParam($request, "enterpriseName");
        $data["talentArrange"] = \StrUtil::getRequestDecodeParam($request, "talentArrange");
        $data["checkState"] = \StrUtil::getRequestDecodeParam($request, "checkState");
        $where = $this->setTalentQuit($data);
        $where[] = ["type", "=", $this->user["type"]];
        $where[] = ["delete", "=", 0];

        $list = TqModel::where($where)->select()->toArray();
        $levelMap = DictApi::selectByParentCode("talent_arrange");

        if ($this->user["type"] == 1) {
            $title = ["姓名", "证件号码", "工作单位", "人才层次", "认定时间", "合同开始时间", "合同截止时间", "入职时间", "离职时间", "离职申报原因",
                "手机号码", "审核状态", "审核意见", "审核通过时间"];
            $keys = ["talentName", "idCard", "enterpriseName", "talentArrangeName", "identifyTime", "starttime", "endtime", "entryTime", "quitTime", "quitReason",
                "phone", "checkStateName", "checkMsg", "passTime"];
        } else {
            $title = ["姓名", "证件号码", "工作单位", "人才层次", "认定时间", "合同开始时间", "合同截止时间", "入职时间", "离职时间",
                "手机号码", "审核状态", "审核意见", "审核通过时间"];
            $keys = ["talentName", "idCard", "enterpriseName", "talentArrangeName", "identifyTime", "starttime", "endtime", "entryTime", "quitTime",
                "phone", "checkStateName", "checkMsg", "passTime"];
        }
        $rows = [];
        foreach ($list as &$item) {
            $item["talentArrangeName"] = $levelMap[$item["talentArrange"]];
            switch ($item["checkState"]) {
                case -1:
                    $item["checkStateName"] = "待提交";
                    break;
                case 1:
                    $item["checkStateName"] = "待审核";
                    break;
                case 2:
                    $item["checkStateName"] = "审核驳回";
                    break;
                case 3:
                    $item["checkStateName"] = "已通过";
                    break;
                case 9:
                    $item["checkStateName"] = "重新提交";
                    break;
            }
            $row = [];
            for ($i = 0; $i < count($keys); $i++) {
                $row[] = $item[$keys[$i]];
            }
            $rows[] = $row;
        }unset($item);

        if (!$rows) {
            return json(["msg" => "没有可导出的内容"]);
        }
        $fileName = "离职变更列表";
        export($title, $rows, $fileName);
    }

    private function setTalentQuit($talentQuitInfo) {
        $where = [];
        if (\StrUtil::isNotEmpAndNull($talentQuitInfo["talentName"])) {
            $where[] = ["talentName", "=", $talentQuitInfo["talentName"]];
        }
        if (\StrUtil::isNotEmpAndNull($talentQuitInfo["idCard"])) {
            $where[] = ["idCard", "=", $talentQuitInfo["IdCard"]];
        }
        if (\StrUtil::isNotEmpAndNull($talentQuitInfo["enterpriseName"])) {
            $where[] = ["enterpriseName", "=", $talentQuitInfo["enterpriseName"]];
        }
        if (\StrUtil::isNotEmpAndNull($talentQuitInfo["talentArrange"])) {
            $where[] = ["talentArrange", "=", $talentQuitInfo["talentArrange"]];
        }
        if ($talentQuitInfo["checkState"] != null) {
            $where[] = ["checkState", "=", $talentQuitInfo["checkState"]];
        }
        return $where;
    }

}
